# DevSpace Examples

This folder contains several examples how to use the DevSpace CLI for various use cases. Below is a table with the examples:  

| Name | Builder | Deployment | Description |
|:------|:----------:|:----------:|:-------------|
| [`quickstart`](https://github.com/devspace-cloud/devspace/tree/master/examples/quickstart) | docker | component | Simple nodejs example how to use devspace with helm |
| [`quickstart-kubectl`](https://github.com/devspace-cloud/devspace/tree/master/examples/quickstart-kubectl) | docker | kubectl | Simple nodejs example how to use devspace with kubectl apply |
| [`kustomize`](https://github.com/devspace-cloud/devspace/tree/master/examples/kustomize) | docker | kustomize | Simple nodejs example how to use devspace with kustomize |
| [`custom-builder`](https://github.com/devspace-cloud/devspace/tree/master/examples/custom-builder) | script | kubectl | Simple custom builder script example |
| [`dependencies`](https://github.com/devspace-cloud/devspace/tree/master/examples/dependencies) | docker | component | Example to show how to use devspace in multiple projects |
| [`dynamic-config`](https://github.com/devspace-cloud/devspace/tree/master/examples/dynamic-config) | none | component | Example that shows the use of config variables |
| [`hooks`](https://github.com/devspace-cloud/devspace/tree/master/examples/hooks) | docker | component | Example that shows how to use hooks |
| [`multiple-configs`](https://github.com/devspace-cloud/devspace/tree/master/examples/multiple-configs) | docker | component | Example that shows how to use multiple DevSpace configs in a single project |
| [`minikube`](https://github.com/devspace-cloud/devspace/tree/master/examples/minikube) | minikube-docker | helm | Minikube example with local registry |
| [`php-mysql-example`](https://github.com/devspace-cloud/devspace/tree/master/examples/php-mysql-example) | docker | component | Example how to easily deploy php and mysql |
| [`profiles`](https://github.com/devspace-cloud/devspace/tree/master/examples/profiles) | docker | component | Example how to use two profiles in one project |
| [`microservices`](https://github.com/devspace-cloud/devspace/tree/master/examples/microservices) | docker | helm & kubectl | Example with simple nodejs and php application that interact |
| [`kaniko`](https://github.com/devspace-cloud/devspace/tree/master/examples/kaniko) | kaniko | helm | Example how to use kaniko instead of docker |
| [`redeploy-instead-of-hot-reload`](https://github.com/devspace-cloud/devspace/tree/master/examples/redeploy-instead-of-hot-reload) | docker | kubectl | Example how to use devspace to redeploy on changes instead of hot reloading |
